from unittest import TestCase
from eventhorizon import signal, emitting
from tests.test_signal import SignalTest


class FlyweightTest(TestCase):
    def test_signal(self):
        t1 = signal('test')
        t2 = signal('test')
        assert t1 is t2

    def test_emitting(self):
        record = []
        for counter, name in enumerate(('this', 'that')):
            function = lambda x=counter: record.append(x)
            signal(name).register(function)

        with emitting(enter='this', exit='that'):
            pass

        assert record == [0, 1]
