from eventhorizon.signal import Signal
from unittest import TestCase


class SignalTest(TestCase):
    def setUp(self):
        self.signal = Signal()
        self.context = []

        @self.signal.register
        def function():
            self.context.append(True)

        self.function = function

    def test_trigger(self):
        self.signal.trigger()
        assert self.context

    def test_silence(self):
        self.signal.silence(self.function)
        self.signal.trigger()
        assert not self.context

    def test_temporary(self):
        with self.signal.connected_to(self.function):
            self.signal.trigger()

        assert len(self.context) == 2
        assert len(self.signal.listeners) == 1

    def test_magic_methods(self):
        assert self.function in self.signal
